Index: Dev/trunk/src/client/qed-client/pages/response.js
===================================================================
--- Dev/trunk/src/client/qed-client/pages/response.js	(revision 486)
+++ Dev/trunk/src/client/qed-client/pages/response.js	(revision 487)
@@ -3,8 +3,5 @@
     "../app/Page",
     "../lib/async",
-    "../model/classes/Response",
-    "../model/classes/Survey",
-    "../model/classes/SurveyRun",
-    "../store",
+    "../model/classes/responses",
     "dojo/_base/declare",
     "dojo/_base/event",
@@ -16,5 +13,5 @@
     "require",
     "dojo/text!./templates/response.html"
-], function(Content, Page, async, Response, Survey, SurveyRun, store, declare, event, json, lang, all, request, when, require, template) {
+], function(Content, Page, async, responses, declare, event, json, lang, all, request, when, require, template) {
     return declare([Page],{
         contextRequire: require,
@@ -28,35 +25,17 @@
             this.inherited(arguments);
             this._disableSubmit();
-            var surveyRunId = this.surveyRunId;
-            var responseId = this.options && this.options.id;
-            if ( surveyRunId && responseId ) {
-                this._loadSurveyAndResponse(surveyRunId,responseId)
-                .then(lang.hitch(this, function() {
-                    if ( this.response.publicationDate ) {
-                        this._showInfo("<div>You already submitted your survey and cannot change it anymore. You can still view your answers here.</div>");
-                        this._disableSubmit();
-                    } else {
-                        this._enableSubmit();
-                    }
-                }), lang.hitch(this,function() {
-                    this._showInfo("<div>The url seems to be incorrect, no survey found.</div>");
-                }));
+            if ( !this.response ) {
+                this._showInfo("<div>The url seems to be incorrect, no response found.</div>");
             } else {
-                throw new Error("No valid uid or survey passed!");
+                this.titleNode.innerHTML = this.response._surveyRun.survey.title || "";
+                this.surveyWidget.set('survey', this.response._surveyRun.survey);
+                this.surveyWidget.set('value', this.response.answers || {});
+                if ( this.response.publicationDate ) {
+                    this._showInfo("<div>You already submitted your survey and cannot change it anymore. You can still view your answers here.</div>");
+                    this._disableSubmit();
+                } else {
+                    this._enableSubmit();
+                }
             }
-        },
-        _loadSurveyAndResponse: function(surveyRunId,responseId){
-            return all([request.get('/api/surveyRuns/'+surveyRunId,{handleAs:'json'}),
-                        request.get('/api/responses/'+responseId,{handleAs:'json'})])
-            .then(lang.hitch(this,function(surveyAndResponse){
-                var surveyRun = surveyAndResponse[0];
-                this.response = surveyAndResponse[1];
-                if ( this.response.surveyRunId !== surveyRunId ) {
-                    throw "Survey does not match the response...";
-                }
-                this.titleNode.innerHTML = Survey.DisplayTitle.get(surveyRun.survey);
-                this.surveyWidget.set('survey', surveyRun.survey);
-                this.surveyWidget.set('value', this.response.answers || {});
-            }));
         },
         _enableSubmit: function() {
@@ -78,10 +57,7 @@
             var answers = this.surveyWidget.get('value');
             this.response.answers = answers;
-            return request.put('/api/responses/'+store.getIdentity(this.response),{
-                handleAs:'json',
-                data:json.toJson(this.response),
-                headers:{"Content-Type": "application/json"}
-            }).then(lang.hitch(this,function(res){
-                this.response._rev = res.rev;
+            return responses.putWithSecret(this.response,this.response.secret)
+            .then(lang.hitch(this,function(response){
+                this.response = response;
                 Content.notify("Your response is saved.");
             }), function(err){
@@ -90,5 +66,5 @@
         },
         _onSubmit: function(e) {
-            this.response.publicationDate = store.timestamp();
+            this.response.publicationDate = new Date();
             this._getAnswersAndSaveResponse()
             .then(lang.hitch(this,function(){
@@ -110,10 +86,6 @@
             this._disableSubmit();
             this.surveyWidget.destroy();
-            request('/api/responses/'+store.getIdentity(this.response)+'?rev='+store.getRevision(this.response),{
-                method: 'DELETE',
-                handleAs:'json',
-                data:json.toJson(this.response),
-                headers:{"Content-Type": "application/json"}
-            }).then(lang.hitch(this,function(res){
+            responses.removeWithSecret(this.response,this.response.secret)
+            .then(lang.hitch(this,function(res){
                 this._showInfo("<div>Your response has been deleted, no answers have been saved.</div>");
                 Content.notify("Your response is deleted.");
Index: Dev/trunk/src/client/qed-client/pages/session.js
===================================================================
--- Dev/trunk/src/client/qed-client/pages/session.js	(revision 486)
+++ Dev/trunk/src/client/qed-client/pages/session.js	(revision 487)
@@ -1,4 +1,4 @@
 define([
-    'dojo/_base/array',
+    /*'dojo/_base/array',
     'dojo/_base/declare',
     'dojo/_base/event',
@@ -12,7 +12,7 @@
     '../model/classes/SessionTemplate',
     '../model/widgets/AccountListView',
-    'dojo/text!./templates/session.html'
+    'dojo/text!./templates/session.html'*/
 ],function(array,declare,event,lang,when,search,store,Page,Router,ThresholdFilteringSelect,SessionTemplate,AccountListView,template){
-    return declare([Page],{
+    /*return declare([Page],{
         templateString: template,
         session: null,
@@ -92,5 +92,5 @@
 
 
-    });
+    });*/
 });
 
Index: Dev/trunk/src/client/qed-client/pages/sessions.js
===================================================================
--- Dev/trunk/src/client/qed-client/pages/sessions.js	(revision 486)
+++ Dev/trunk/src/client/qed-client/pages/sessions.js	(revision 487)
@@ -1,4 +1,4 @@
 define([
-    'dojo/_base/declare',
+    /*'dojo/_base/declare',
     'dojo/_base/lang',
     'dojo/date/stamp',
@@ -7,7 +7,7 @@
     '../app/Page',
     '../widgets/ObjectBox',
-    'dojo/text!./templates/sessions.html'
+    'dojo/text!./templates/sessions.html'*/
 ],function(declare,lang,dateStamp,store,Router,Page,ObjectBox,template){
-    return declare([Page],{
+    /*return declare([Page],{
         templateString: template,
         templateActions: null,
@@ -18,8 +18,8 @@
             this.templateActions = {
                 "Edit": function(obj){
-                    Router.go('/session/'+store.getIdentity(obj));
+                    Router.go('/session/'+obj.get('id'));
                 },
                 "Delete": lang.hitch(this,function(obj){
-                    store.remove(store.getIdentity(obj),store.getRevision(obj))
+                    obj.remove()
                     .then(lang.hitch(this,function(){
                         this._refresh();
@@ -30,8 +30,8 @@
             this.sessionActions = {
                 "Facilitate": function(obj){
-                    Router.go('run',{uid:store.getIdentity(obj)});
+                    Router.go('run',{uid: obj.get('id')});
                 },
                 "Delete": lang.hitch(this,function(obj){
-                    store.remove(store.getIdentity(obj),store.getRevision(obj))
+                    obj.remove()
                     .then(lang.hitch(this,function(){
                         this._refresh();
@@ -48,4 +48,5 @@
         },
         _refreshByType: function(type,container,actions) {
+            // FIXME
             store.query("_design/default/_view/by_type",{key:type})
             .forEach(lang.hitch(this,function(obj){
@@ -61,4 +62,5 @@
         },
         _publishSession: function(sessionTemplate) {
+            // FIXME
             var session = lang.clone(sessionTemplate);
             delete session[store.idProperty];
@@ -73,4 +75,4 @@
             }));
         }
-    });
+    });*/
 });
Index: Dev/trunk/src/client/qed-client/pages/survey.js
===================================================================
--- Dev/trunk/src/client/qed-client/pages/survey.js	(revision 486)
+++ Dev/trunk/src/client/qed-client/pages/survey.js	(revision 487)
@@ -2,8 +2,7 @@
     "../app/Page",
     "../app/Router",
-    "../model/classes/Survey",
+    "../model/classes/surveys",
     "../model/widgets/QuestionListView",
     "../model/widgets/TabbedQuestionBrowser",
-    "../store",
     "dojo/_base/array",
     "dojo/_base/declare",
@@ -13,5 +12,5 @@
     "require",
     "dojo/text!./templates/survey.html"
-], function(Page, Router, Survey, QuestionListView, TabbedQuestionBrowser, store, array, declare, event, lang, when, require, template) {
+], function(Page, Router, surveys, QuestionListView, TabbedQuestionBrowser, array, declare, event, lang, when, require, template) {
     return declare([Page],{
         contextRequire: require,
@@ -63,12 +62,12 @@
         _loadSurvey: function() {
             if ( this.surveyId === "new" ) {
-                this.survey = Survey.create();
+                this.survey = surveys.create();
                 this.refresh();
             } else {
-                when(store.get(this.surveyId))
+                when(surveys.load(this.surveyId))
                 .then(lang.hitch(this,function(survey){
                     this.survey = survey;
                     this.questionList.set('value',
-                                          Survey.Questions.get(this.survey));
+                                          this.survey.questions);
                     this.refresh();
                 }));
@@ -79,5 +78,5 @@
         },
         refresh: function() {
-            this.titleNode.innerHTML = Survey.DisplayTitle.get(this.survey) || "(set title in properties)";
+            this.titleNode.innerHTML = this.survey.title || "(set title in properties)";
             this.propertiesDialog.set('value',this.survey);
         },
@@ -100,5 +99,5 @@
         _onSave: function(evt) {
             this.survey.questions = this.questionList.get('value');
-            store.put(this.survey)
+            surveys.save(this.survey)
             .then(function() { 
                 Router.go('/surveys');
@@ -111,5 +110,5 @@
         },
         _onShowPreview: function() {
-            Router.go('/previewSurvey/'+store.getIdentity(this.survey),{
+            Router.go('/previewSurvey/'+this.survey._id,{
                 preview: true
             });
Index: Dev/trunk/src/client/qed-client/pages/surveyRun.js
===================================================================
--- Dev/trunk/src/client/qed-client/pages/surveyRun.js	(revision 486)
+++ Dev/trunk/src/client/qed-client/pages/surveyRun.js	(revision 487)
@@ -4,7 +4,8 @@
     "../app/Router",
     "../lib/func",
-    "../model/classes/SurveyRun",
-    "../store",
+    "../model/classes/responses",
+    "../model/classes/surveyRuns",
     "../widgets/LineWithActionsWidget",
+    "dojo/_base/array",
     "dojo/_base/declare",
     "dojo/_base/event",
@@ -13,5 +14,5 @@
     "require",
     "dojo/text!./templates/surveyRun.html"
-], function(Content, Page, Router, func, SurveyRun, store, LineWithActionsWidget, declare, event, lang, when, require, template) {
+], function(Content, Page, Router, func, responses, surveyRuns, LineWithActionsWidget, array, declare, event, lang, when, require, template) {
     return declare([Page],{
         contextRequire: require,
@@ -24,5 +25,4 @@
             if ( this.surveyRunId ) {
                 this._loadSurveyRun();
-                this._loadResponses();
             } else {
                 throw "No valid uid or survey passed!";
@@ -30,41 +30,44 @@
         },
         _loadSurveyRun: function() {
-            when(store.get(this.surveyRunId))
+            when(surveyRuns.load(this.surveyRunId))
             .then(lang.hitch(this,function(surveyRun){
                 this.surveyRun = surveyRun;
                 this.refreshSurveyRun();
+                this._loadResponses();
             }));
         },
         refreshSurveyRun: function() {
-            this.titleNode.innerHTML = SurveyRun.DisplayTitle.get(this.surveyRun);
-            this.surveySummaryWidget.set('value',SurveyRun.Survey.get(this.surveyRun));
+            this.titleNode.innerHTML = this.surveyRun.title || "";
+            this.surveySummaryWidget.set('value',this.surveyRun.survey);
             this.surveyRunWidget.set('value',this.surveyRun);
             this._onPropChange();
         },
         _loadResponses: function() {
-            when(store.query("_design/responses/_view/by_surveyrun",{key:this.surveyRunId}))
-            .forEach(lang.hitch(this,function(response){
-                var actions = {
-                    view: {
-                        callback: function(){},
-                        properties: {
-                            title: "View response"
-                        }
-                    }
-                };
-                if ( !response.publicationDate ) {
-                    actions.remove = {
-                        callback: function(){},
-                        properties: {
-                            title: "Remove response"
+            responses.query({surveyRunId:surveyRuns.getId(this.surveyRun)})
+            .then(lang.hitch(this,function(allResponses){
+                array.forEach(allResponses, function(response){
+                    var actions = {
+                        view: {
+                            callback: function(){},
+                            properties: {
+                                title: "View response"
+                            }
                         }
                     };
-                }
-                var w = new LineWithActionsWidget({
-                    actions: actions
-                });
-                var responseId = store.getIdentity(response);
-                w.set('title',this._link(this._getResponseURL(this.surveyRunId,responseId),responseId));
-                w.placeAt(this.responsesNode);
+                    if ( !response.publicationDate ) {
+                        actions.remove = {
+                            callback: function(){},
+                            properties: {
+                                title: "Remove response"
+                            }
+                        };
+                    }
+                    var w = new LineWithActionsWidget({
+                        actions: actions
+                    });
+                    var rid = responses.getId(response);
+                    w.set('title',this._link(this._buildResponseURL(response),rid),rid);
+                    w.placeAt(this.responsesNode);
+                }, this);
             }));
         },
@@ -73,5 +76,5 @@
             if ( surveyRun.mode === "open" ) {
                 this.runURLNode.innerHTML =
-                    this._link(this._getGeneralURL(store.getIdentity(this.surveyRun)));
+                    this._link(this._buildGeneralURL(this.surveyRun));
             } else {
                 this.runURLNode.innerHTML =
@@ -79,9 +82,9 @@
             }
         },
-        _getGeneralURL: function(surveyRunId) {
-            return 'response.html#!/'+surveyRunId;
+        _buildGeneralURL: function(surveyRun) {
+            return 'response.html#!/surveyRuns/'+surveyRuns.getId(surveyRun)+'!secret='+surveyRun.secret;
         },
-        _getResponseURL: function(surveyRunId,responseId) {
-            return 'response.html#!/'+surveyRunId+'!id='+responseId;
+        _buildResponseURL: function(response) {
+            return 'response.html#!/responses/'+responses.getId(response)+'!secret='+response.secret;
         },
         _link: function(url,label) {
@@ -92,10 +95,5 @@
                 lang.mixin(this.surveyRun,this.surveyRunWidget.get('value'));
 
-                var SD = SurveyRun.StartDate;
-                var ED = SurveyRun.EndDate;
-                SD.set(this.surveyRun, SD.get(this.surveyRun));
-                ED.set(this.surveyRun, ED.get(this.surveyRun));
-
-                store.put(this.surveyRun)
+                surveyRuns.save(this.surveyRun)
                 .then(function() { 
                     Router.go('/surveys');
Index: Dev/trunk/src/client/qed-client/pages/surveys.js
===================================================================
--- Dev/trunk/src/client/qed-client/pages/surveys.js	(revision 486)
+++ Dev/trunk/src/client/qed-client/pages/surveys.js	(revision 487)
@@ -1,16 +1,15 @@
 define([
-    'dojo/_base/array',
-    'dojo/_base/declare',
-    'dojo/_base/lang',
-    'dojo/when',
-    '../store',
-    '../app/Content',
-    '../app/Page',
-    '../app/Router',
-    '../model/classes/Survey',
-    '../model/classes/SurveyRun',
-    '../widgets/LineWithActionsWidget',
-    'dojo/text!./templates/surveys.html'
-],function(array,declare,lang,when,store,Content,Page,Router,Survey,SurveyRun,LineWithActionsWidget,template){
+    "../app/Content",
+    "../app/Page",
+    "../app/Router",
+    "../model/classes/surveys",
+    "../model/classes/surveyRuns",
+    "../widgets/LineWithActionsWidget",
+    "dojo/_base/array",
+    "dojo/_base/declare",
+    "dojo/_base/lang",
+    "dojo/when",
+    "dojo/text!./templates/surveys.html"
+], function(Content, Page, Router, surveys, surveyRuns, LineWithActionsWidget, array, declare, lang, when, template) {
     return declare([Page],{
         templateString: template,
@@ -25,6 +24,7 @@
         _onPublishSurvey:function(survey){
             var self = this;
-            survey.publicationDate = store.timestamp();
-            store.put(survey).then(function(){
+            survey.publicationDate = new Date();
+            surveys.save(survey)
+            .then(function(){
                 self.refreshDrafts();
                 self.refreshPublished();
@@ -35,5 +35,5 @@
         _onDeleteSurvey:function(survey){
             var self = this;
-            store.remove(store.getIdentity(survey),store.getRevision(survey))
+            surveys.remove(survey)
             .then(function(){
                 self.refreshDrafts();
@@ -43,13 +43,13 @@
         },
         _onEditSurvey:function(survey){
-            Router.go('/survey/'+store.getIdentity(survey));
+            Router.go('/survey/'+survey._id);
         },
         _onPreviewSurvey:function(survey){
-            Router.go('/previewSurvey/'+store.getIdentity(survey));
+            Router.go('/previewSurvey/'+survey._id);
         },
         _onRunSurvey:function(survey){
-            var surveyRun = SurveyRun.create();
-            SurveyRun.Survey.set(surveyRun,survey);
-            store.put(surveyRun)
+            var surveyRun = surveyRuns.create();
+            surveyRun.survey = survey;
+            surveyRuns.save(surveyRun)
             .then(lang.hitch(this,function(surveyRun){
                 this._onRunDetails(surveyRun);
@@ -59,5 +59,5 @@
         },
         _onRunDetails: function(surveyRun) {
-            Router.go('/surveyRun/'+store.getIdentity(surveyRun));
+            Router.go('/surveyRun/'+surveyRun._id);
         },
         refresh: function() {
@@ -68,10 +68,9 @@
         refreshDrafts: function() {
             this.draftsContainer.set('content','');
-            when(store.query("_design/surveys/_view/drafts"),
-                    lang.hitch(this,function(surveys) {
+            when(surveys.query({drafts:true}), lang.hitch(this,function(surveys) {
                 this.draftsTab.set('title','Drafts ('+surveys.length+')');
                 array.forEach(surveys,function(survey){
                     var w = new LineWithActionsWidget({
-                        title: Survey.DisplayTitle.get(survey) || '(unnamed)',
+                        title: survey.title || '(unnamed)',
                         actions: [{
                             callback: lang.hitch(this,'_onPublishSurvey',survey),
@@ -110,10 +109,9 @@
         refreshPublished: function() {
             this.publishedContainer.set('content','');
-            when(store.query("_design/surveys/_view/published"),
-                    lang.hitch(this, function(surveys) {
+            when(surveys.query({published:true}), lang.hitch(this, function(surveys) {
                 this.publishedTab.set('title','Published ('+surveys.length+')');
                 array.forEach(surveys,function(survey){
                     var w = new LineWithActionsWidget({
-                        title: Survey.DisplayTitle.get(survey),
+                        title: survey.title || "",
                         actions:[{
                             callback: lang.hitch(this,'_onPreviewSurvey',survey),
@@ -138,10 +136,9 @@
         refreshRuns: function() {
             this.runsContainer.set('content','');
-            when(store.query("_design/default/_view/by_type",{key:'SurveyRun'}),
-                    lang.hitch(this,function(surveyRuns){
+            when(surveyRuns.query(), lang.hitch(this,function(surveyRuns){
                 this.runsTab.set('title','Runs ('+surveyRuns.length+')');
                 array.forEach(surveyRuns,function(surveyRun){
                     var w = new LineWithActionsWidget({
-                        title: SurveyRun.DisplayTitle.get(surveyRun),
+                        title: surveyRun.title || "",
                         actions:[{
                             callback: lang.hitch(this,'_onRunDetails',surveyRun),
Index: Dev/trunk/src/client/qed-client/response.js
===================================================================
--- Dev/trunk/src/client/qed-client/response.js	(revision 486)
+++ Dev/trunk/src/client/qed-client/response.js	(revision 487)
@@ -4,8 +4,7 @@
     "./app/Path",
     "./lib/async",
-    "./model/classes/Response",
-    "./model/classes/SurveyRun",
+    "./model/classes/responses",
+    "./model/classes/surveyRuns",
     "./pages/response",
-    "./store",
     "dojo/_base/json",
     "dojo/date",
@@ -16,5 +15,5 @@
     "./stddeps",
     "dojo/domReady!"
-], function(Content, Page, Path, async, Response, SurveyRun, ResponsePage, store, json, date, locale, hash, parser, request) {
+], function(Content, Page, Path, async, responses, surveyRuns, ResponsePage, json, date, locale, hash, parser, request) {
     parser.parse();
     Content.startup();
@@ -26,63 +25,27 @@
     }
 
-    var path = new Path('/:surveyRunId');
+    var path = new Path('/:type/:id');
     var params = path.match(hash());
     params.options = params.options || {};
-
-    if ( !params || !params.surveyRunId ) {
+    
+    if ( params && params.type === 'surveyRuns' ) {
+        var response = responses.create();
+        response.surveyRunId = params.id;
+        responses.postWithSecret(response,params.options.secret)
+        .then(setContent,function(err){ error(err.error); });
+    } else if ( params && params.type === 'responses' ) {
+        responses.getWithSecret(params.id,params.options.secret)
+        .then(setContent,function(err){ error(err.error); });
+    } else {
         error("Something is wrong with the URL, don't know what survey to show you. Sorry.");
-        return;
     }
 
-    var surveyRunId = params.surveyRunId;
-
-    function checkDates(surveyRun) {
-        var now = new Date();
-        var startDate = SurveyRun.StartDate.get(surveyRun);
-        var endDate = SurveyRun.EndDate.get(surveyRun);
-        if ( startDate && date.compare(startDate,now) > 0 ) {
-            error("This survey will start on "+locale.format(startDate,'date'));
-            throw false;
-        }
-        if ( endDate && date.compare(now,endDate) > 0 ) {
-            error("This survey ended on "+locale.format(endDate,'date'));
-            throw false;
-        }
+    function setContent(response) {
+        hash(Path.format("/responses/"+responses.getId(response),
+                         {secret:response.secret}));
+        Content.set(new ResponsePage({
+            response: response
+        }));
     }
 
-    request.get('/api/surveyRuns/'+surveyRunId,{handleAs:'json'})
-    .then(function(surveyRun){
-        checkDates(surveyRun);
-        if ( params.options.id ) {
-            return params.options.id;
-        } else {
-            if ( surveyRun.mode === "open") {
-                var response = Response.create();
-                response.surveyRunId = surveyRunId;
-                return request.post('/api/responses',{
-                    handleAs:'json',
-                    data:json.toJson(response),
-                    headers:{"Content-Type": "application/json"}
-                }).then(function(res){
-                    return res.id;
-                });
-            } else {
-                error("Cannot respond to closed survey without response id. Sorry.");
-                throw false;
-            }
-        }
-        return surveyRun;
-    },function(){
-        error("No running survey found for the given id. Sorry.");
-        throw false;
-    })
-    .then(function(responseId){
-        hash(Path.format("/"+surveyRunId,{ id: responseId }));
-        Content.set(new ResponsePage({
-            surveyRunId: surveyRunId,
-            options: {
-                id: responseId
-            }
-        }));
-    });
 });
Index: Dev/trunk/src/client/qed-client/routes.js
===================================================================
--- Dev/trunk/src/client/qed-client/routes.js	(revision 486)
+++ Dev/trunk/src/client/qed-client/routes.js	(revision 487)
@@ -1,13 +1,11 @@
 define([
-    './pages/index',
-    './pages/questions',
-    './pages/question',
-    './pages/surveys',
-    './pages/survey',
-    './pages/surveyRun',
-    './pages/sessions',
-    './pages/session',
-    './pages/previewSurvey'
-],function(index,questions,question,surveys,survey,surveyRun,sessions,session,previewSurvey){
+    "./pages/index",
+    "./pages/previewSurvey",
+    "./pages/question",
+    "./pages/questions",
+    "./pages/survey",
+    "./pages/surveyRun",
+    "./pages/surveys"
+], function(index, previewSurvey, question, questions, survey, surveyRun, surveys) {
 
     return [
Index: Dev/trunk/src/client/qed-client/session.coffee
===================================================================
--- Dev/trunk/src/client/qed-client/session.coffee	(revision 486)
+++ Dev/trunk/src/client/qed-client/session.coffee	(revision 487)
@@ -2,7 +2,8 @@
     "dojo/_base/declare",
     "dojo/_base/json",
+    "dojo/Deferred",
     "dojo/Evented",
     "dojo/request"
-], (declare, json, Evented, request) ->
+], (declare, json, Deferred, Evented, request) ->
     Session = declare [Evented],
         info: null
@@ -18,5 +19,5 @@
                 @_set res
             , () =>
-                throw (@_set null)
+                new Deferred().reject (@_set null)
 
         login: (username, password) ->
@@ -30,5 +31,5 @@
                 @_set res
             , () =>
-                throw (@_set null)
+                new Deferred().reject (@_set null)
 
         logout: () ->
@@ -45,5 +46,5 @@
                 @info = newInfo
                 @emit 'change', @info
-                @info
+            @info
 
     new Session()
